import {
  numberOfChemicalsSelector,
  loadingChemicalsStatusSelector,
} from '@/redux/chemicals/chemicals.selectors';
import { useAppSelector } from '@/redux/hooks/useAppSelector';
import { AccordionItem, AccordionItemHeading, AccordionItemButton } from '@/shared/Accordion';

export const ChemicalsAccordion = (): JSX.Element => {
  const chemicalsNumber = useAppSelector(numberOfChemicalsSelector);
  const drugsState = useAppSelector(loadingChemicalsStatusSelector);

  return (
    <AccordionItem>
      <AccordionItemHeading>
        <AccordionItemButton variant="non-expandable">
          Chemicals
          {drugsState === 'pending' && ' (Loading...)'}
          {drugsState === 'succeeded' && ` (${chemicalsNumber})`}
        </AccordionItemButton>
      </AccordionItemHeading>
    </AccordionItem>
  );
};
